// ----------------------------------------------------------------------------
// Chai Friendly
// https://github.com/ihordiachenko/eslint-plugin-chai-friendly
// ----------------------------------------------------------------------------

const rules = {
    'no-unused-expressions': 'off',
    'babel/no-unused-expressions': 'off',
    'flowtype/no-unused-expressions': 'off',
    'chai-friendly/no-unused-expressions': [
        'error',
        {
            allowShortCircuit: false,
            allowTernary: false,
            allowTaggedTemplates: false,
        },
    ],
};

module.exports = {
    plugins: ['chai-friendly'],

    rules: {},

    overrides: [
        {
            files: ['*.*{spec,test}.{js,ts,tsx}', '**/__{mocks,tests}__/**/*.{js,ts,tsx}'],
            rules,
        },
    ],
};
