// ----------------------------------------------------------------------------
// Node
// ----------------------------------------------------------------------------

const rules = {
    // enforce `return` after a callback
    'callback-return': 'off', // TODO ['error', ['callback', 'cb', 'next']]

    // disallow `require()` outside of the top-level module scope
    'global-require': 'off',

    // enforce error handling in callbacks
    'handle-callback-err': 'off', // TODO ['error', '^.*(e|E)rr(or)?$']

    // disallow use of the Buffer() constructor
    'no-buffer-constructor': 'error',

    // disallow mixing regular variable and require declarations
    'no-mixed-requires': 'off', // TODO

    // disallow use of `new` operator with the `require` function
    'no-new-require': 'error',

    // disallow string concatenation with `__dirname` and `__filename`
    'no-path-concat': 'error',

    // disallow use of `process.env`
    'no-process-env': 'off',

    // disallow `process.exit()`
    'no-process-exit': 'off',

    // restrict usage of specified node imports
    'no-restricted-imports': 'off',

    // restrict usage of specified node modules
    'no-restricted-modules': 'off',

    // disallow use of synchronous methods
    'no-sync': 'off',
};

module.exports = {
    rules,
};
