// ----------------------------------------------------------------------------
// Cypress
// https://github.com/cypress-io/eslint-plugin-cypress
// ----------------------------------------------------------------------------

const rules = {
    // Prevent assigning return values of cy calls
    'cypress/no-assigning-return-values': 'error',

    // Prevent waiting for arbitrary time periods
    'cypress/no-unnecessary-waiting': 'error',

    // Disallow using force: true with action commands
    'cypress/no-force': 'warn',

    // Ensure screenshots are preceded by an assertion
    'cypress/assertion-before-screenshot': 'warn',

    // Only allow data-* attribute selectors
    'cypress/require-data-selectors': 'warn',
};

module.exports = {
    plugins: ['cypress'],

    overrides: [
        {
            files: ['*.*{spec,test}.{js,ts,tsx}', '**/__{mocks,tests}__/**/*.{js,ts,tsx}'],
            rules,
        },
    ],
};
