// ----------------------------------------------------------------------------
// Jest DOM
// https://github.com/testing-library/eslint-plugin-jest-dom
// ----------------------------------------------------------------------------

const rules = {
    // prefer toBeChecked over checking attributes
    'jest-dom/prefer-checked': 'error',

    // Prefer toBeEmpty over checking innerHTML
    'jest-dom/prefer-empty': 'error',

    // prefer toBeDisabled or toBeEnabled over checking attributes
    'jest-dom/prefer-enabled-disabled': 'error',

    // prefer toHaveFocus over checking document.activeElement
    'jest-dom/prefer-focus': 'error',

    // prefer toBeRequired over checking properties
    'jest-dom/prefer-required': 'error',

    // prefer toHaveAttribute over checking getAttribute/hasAttribute
    'jest-dom/prefer-to-have-attribute': 'error',

    // Prefer toHaveTextContent over checking element.textContent
    'jest-dom/prefer-to-have-text-content': 'error',
};

module.exports = {
    plugins: ['jest-dom'],

    overrides: [
        {
            files: ['*.*{spec,test}.{js,ts,tsx}', '**/__{mocks,tests}__/**/*.{js,ts,tsx}'],
            rules,
        },
    ],
};
