const rules = {
    // ----------------------------------------------------------------------------
    // Promise
    // https://github.com/xjamundx/eslint-plugin-promise
    // ----------------------------------------------------------------------------

    // Enforces the use of catch on un-returned promises.
    'promise/catch-or-return': 'off', // TODO

    // Avoid wrapping values in Promise.resolve or Promise.reject when not needed.
    'promise/no-return-wrap': 'off', // TODO

    // Enforce consistent param names when creating new promises.
    'promise/param-names': 'error',

    // Return inside each then to create readable and reusable Promise chains.
    'promise/always-return': 'off', // TODO

    // In an ES5 environment, make sure to create a Promise constructor before using.
    'promise/no-native': 'off',

    // Avoid nested .then() or .catch() statements
    'promise/no-nesting': 'error', // TODO

    // Avoid using promises inside of callbacks
    'promise/no-promise-in-callback': 'off', // TODO

    // Avoid calling cb() inside of a then() (use nodeify] instead)
    'promise/no-callback-in-promise': 'off', // TODO

    // Avoid creating new promises outside of utility libs (use pify instead)
    'promise/avoid-new': 'off',

    // Avoid calling new on a Promise static method
    'promise/no-new-statics': 'off', // TODO

    // Disallow return statements in finally()
    'promise/no-return-in-finally': 'off', // TODO

    // Ensures the proper number of arguments are passed to Promise functions
    'promise/valid-params': 'error',

    // Prefer await to then() for reading Promise values
    'promise/prefer-await-to-then': 'off', // TODO

    // Prefer async/await to the callback pattern
    'promise/prefer-await-to-callbacks': 'off', // TODO
};

module.exports = {
    plugins: ['promise'],

    rules,
};
