// ----------------------------------------------------------------------------
// React Native
// https://github.com/Intellicode/eslint-plugin-react-native
// ----------------------------------------------------------------------------

const rules = {
    // Detect StyleSheet rules which are not used in your React components
    'react-native/no-unused-styles': 'warn',

    // Require style definitions to be sorted alphabetically
    'react-native/sort-styles': 'off',

    // Enforce using platform specific filenames when necessary
    'react-native/split-platform-components': 'warn',

    // Detect JSX components with inline styles that contain literal values
    'react-native/no-inline-styles': 'warn',

    // Detect StyleSheet rules and inline styles containing color literals instead of variables
    'react-native/no-color-literals': 'warn',

    // Detect raw text outside of Text component
    'react-native/no-raw-text': 'warn',

    // No style arrays that have 1 element only `<View style={[{height: 10}]}/>`
    'react-native/no-single-element-style-arrays': 'warn',
};

module.exports = {
    plugins: ['react-native'],

    rules,
};
