module.exports = {
    extends: ['./react', './lib/rules/react-native', './lib/rules/react-native-a11y'].map(
        require.resolve
    ),

    // env: {
    //     // https://github.com/react-native-community/eslint-plugin-react-native-globals
    //     // No longer updated
    //     'react-native/react-native': true,
    // },

    // Copied from https://github.com/facebook/react-native/blob/master/packages/eslint-config-react-native-community/index.js#L80
    // Since old repo is no longer updated
    globals: {
        __DEV__: true,
        __dirname: false,
        __fbBatchedBridgeConfig: false,
        alert: false,
        cancelAnimationFrame: false,
        cancelIdleCallback: false,
        clearImmediate: true,
        clearInterval: false,
        clearTimeout: false,
        console: false,
        document: false,
        ErrorUtils: false,
        escape: false,
        Event: false,
        EventTarget: false,
        exports: false,
        fetch: false,
        FormData: false,
        global: false,
        Headers: false,
        Intl: false,
        Map: true,
        module: false,
        navigator: false,
        process: false,
        Promise: true,
        requestAnimationFrame: true,
        requestIdleCallback: true,
        require: false,
        Set: true,
        setImmediate: true,
        setInterval: false,
        setTimeout: false,
        URL: false,
        URLSearchParams: false,
        WebSocket: true,
        window: false,
        XMLHttpRequest: false,

        // Detox
        detox: false,
        device: false,
        expect: false,
        waitFor: false,
        element: false,
        by: false,
    },

    reportUnusedDisableDirectives: true,

    plugins: ['import'],

    // https://github.com/benmosher/eslint-plugin-import/blob/master/config/react-native.js
    // settings:
    //   import/resolver:
    //     node:
    //       // Note: will not complain if only _one_ of these files exists.
    //       extensions:
    //         - '.js'
    //         - '.web.js'
    //         - '.ios.js'
    //         - '.android.js'

    settings: {
        'import/resolver': 'reactnative',
    },

    rules: {
        // Forbid foreign propTypes
        // Since RN doesn't remove proptypes, not necessary to use this
        'react/forbid-foreign-prop-types': 'off',
    },
};
