module.exports = {
    extends: [
        './esnext',
        // './jest',
        // './import',

        './lib/rules/react',
        './lib/rules/react-hooks',
        './lib/rules/jsx-a11y',
    ].map(require.resolve),

    parserOptions: {
        ecmaFeatures: {
            jsx: true,
        },
    },

    env: {
        node: true,
    },

    reportUnusedDisableDirectives: true,

    settings: {
        react: {
            pragma: 'React',
            version: 'detect',
            flowVersion: 'detect',
        },
        linkComponents: [{ name: 'Link', linkAttribute: 'to' }],
    },

    // https://github.com/benmosher/eslint-plugin-import/blob/master/config/react.js
    // settings:
    //   import/extensions:
    //     - '.js'
    //     - '.jsx'

    // settings:
    //     import/resolver: webpack
    //     import/extensions:
    //         - '.js'
    //         - '.jsx'

    // TODO try this - https://github.com/airbnb/javascript/blob/master/packages/eslint-config-airbnb-base/rules/imports.js
    // settings: {
    //     'import/resolver': {
    //       node: {
    //         extensions: ['.mjs', '.js', '.json']
    //       }
    //     },
    //     'import/extensions': [
    //       '.js',
    //       '.mjs',
    //       '.jsx',
    //     ],
    //     'import/core-modules': [
    //     ],
    //     'import/ignore': [
    //       'node_modules',
    //       '\\.(coffee|scss|css|less|hbs|svg|json)$',
    //     ],
    // },

    rules: {
        'consistent-return': 'off',
        'class-methods-use-this': [
            // TODO
            'warn',
            {
                exceptMethods: [
                    'render',
                    'getInitialState',
                    'getDefaultProps',
                    'getChildContext',
                    'componentWillMount',
                    'UNSAFE_componentWillMount',
                    'componentDidMount',
                    'componentWillReceiveProps',
                    'UNSAFE_componentWillReceiveProps',
                    'shouldComponentUpdate',
                    'componentWillUpdate',
                    'UNSAFE_componentWillUpdate',
                    'componentDidUpdate',
                    'componentWillUnmount',
                    'componentDidCatch',
                    'getSnapshotBeforeUpdate',
                ],
            },
        ],
    },

    overrides: [
        {
            files: ['*.ts', '*.tsx'],
            rules: require('./lib/rules/react-typescript'),
        },
    ],
};
