module.exports = {
    extends: ['./esnext', 'plugin:import/typescript', './lib/rules/typescript'],

    plugins: ['@typescript-eslint', 'import'],

    settings: {
        'import/parsers': {
            '@typescript-eslint/parser': ['.ts', '.tsx'],
        },
        'import/resolver': {
            typescript: {},
        },
    },

    reportUnusedDisableDirectives: true,

    overrides: [
        {
            parser: '@typescript-eslint/parser',
            parserOptions: {
                ecmaVersion: 2020,
                sourceType: 'module',
                // project: 'tsconfig.json',
                // tsconfigRootDir: './',
            },
            files: ['*.ts', '*.tsx'],
            rules: {
                // Checked by Typescript - ts(2378)
                'getter-return': 'off',

                // Checked by Typescript - ts(2300)
                'no-dupe-args': 'off',

                // Checked by Typescript - ts(1117)
                'no-dupe-keys': 'off',

                // Checked by Typescript - ts(7027)
                'no-unreachable': 'off',

                // Checked by Typescript - ts(2367)
                'valid-typeof': 'off',
                'babel/valid-typeof': 'off',

                // Checked by Typescript - ts(2588)
                'no-const-assign': 'off',

                // Checked by Typescript - ts(2588)
                'no-new-symbol': 'off',

                // Checked by Typescript - ts(2376)
                'no-this-before-super': 'off',

                // This is checked by Typescript using the option `strictNullChecks`.
                'no-undef': 'off',

                // This is already checked by Typescript.
                'no-redeclare': 'off',

                // Handled by Typescript
                'no-shadow': 'off',
                // 'sort-class-members/sort-class-members': 'off',

                // Does not support TS equivalent
                'import/no-unresolved': 'off',
                'import/no-extraneous-dependencies': 'off',

                // Flag typedef files with multiple modules with export default
                'import/export': 'off',

                // Breaks @typescript-eslint/parser
                strict: 'off',
                'array-callback-return': 'off',
            },
        },
    ],
};
